%atribute(ListaAtribute).
atribute([ploua,vant,cald]).

%atribut(Nume,Valoare1,Valoare2).
atribut(ploua,da,nu).
atribut(vant,da,nu).
atribut(cald,da,nu).

%categorie(ValAdev,ValFals).
categorie(tenis,sah).

%exemple de antrenare
joc([([[ploua,da],[vant,da],[cald,da]],sah),
([[ploua,da],[vant,da],[cald,nu]],sah),
([[ploua,da],[vant,nu],[cald,da]],sah),
([[ploua,da],[vant,nu],[cald,nu]],sah),
([[ploua,nu],[vant,da],[cald,da]],tenis),
([[ploua,nu],[vant,da],[cald,nu]],sah),
([[ploua,nu],[vant,nu],[cald,da]],tenis),
([[ploua,nu],[vant,nu],[cald,nu]],tenis)]).

log2(0,0) :- !.
log2(X,L) :- log(2,A), log(X,B), L is B/A.

entropy([],0).
entropy(0,0) :- !.
entropy(1,0) :- !.
entropy(X,E) :- number(X), log2(X,L), E is -X*L,!.
entropy([H|T],E) :- entropy(H,E1), entropy(T,E2), E is E1+E2.

adev(X,D,N) :- atribut(X,Da,Nu), categorie(A,_), count(X,Da,A,D), count(X,Nu,A,N).
fals(X,D,N) :- atribut(X,Da,Nu), categorie(_,F), count(X,Da,F,D), count(X,Nu,F,N).


extrag(_,[],[]).
extrag(Vc,[(L1,Vc)|T],[L1|L2]) :- extrag(Vc,T,L2).
extrag(Vc,[_|T],L) :- extrag(Vc,T,L).
extrage(Vc,L) :- joc(J), extrag(Vc,J,L).
%count(Atribut,ValAtribut, ValCategorie, Numar).
count(X,Va,Vc,N) :- extrage(Vc,L), numara(X,Va,L,N).
numara(_,_,[],0).
numara(X,Va,[H|T],N) :- exista(X,Va,H,E), numara(X,Va,T,N1), N is E+N1.
%exista(Atribut,Valoare,Lista,Exista)
exista(_,_,[],0).
exista(X,Va,[[X,Va]|_],1).
exista(X,Va,[_|T],E) :- exista(X,Va,T,E),!. 


%calcentr(AtributeExemplu,ListaAtributeEntropii)
%calcentr([ploua,vant,cald],[(ploua,0.296),(vant,0.546),(cald,0.546)]).

calcentr(X,(X,E)) :- adev(X,D1,N1), fals(X,D2,N2), P1 is D1/4, P2 is N1/4, P3 is D2/4, P4 is N2/4, entropy([P1,P2],E1), entropy([P3,P4],E2), E is (E1+E2)/2, !.
calcentropii([],[]).
calcentropii([H|T],[E|TE]) :- calcentr(H,E), calcentropii(T,TE).

%entropia trebuie recalculata dupa adaugarea fiecarui nod,
%pe setul restrans de exemple ?!?!
entropia(LE) :- atribute(L), calcentropii(L,LE).

%min(Lista,RestLista,Maxim)
min(L,R,M) :- minim(L,M), del(M,L,R).
minim([H],H).
minim([H|T],M) :- minim(T,N), mm(N,H,M).
mm((I,A),(_,B),(I,A)) :- A<B,!.
mm(_,B,B).

del(_,[],[]).
del(A,[A|T],R) :- del(A,T,R),!.
del(A,[H|T],[H|R]) :- del(A,T,R).



%cert(ListaExem)
cert([_|[]]).
cert([(_,V)|T]) :- cert(T), T=[(_,V)|_].

%categorii(ListaEx,ListaCateg)
categorii([],[]).
categorii([(_,C)|R],[C|Cr]) :- categorii(R,Cr).

%ponderent(ListaPonderi,CategoriePonderenta,Pondere).
ponderent([(A,N)],A,N).
ponderent([(A,N)|R],A,N) :- ponderent(R,_,M),N>M,!.
ponderent([_|R],C,M) :- ponderent(R,C,M).

%ponderi(ListaCateg,ListaPonderi)
ponderi([],[]).
ponderi([C],[(C,1)]).
ponderi([A|R],[(A,N)|Rp]) :- del(A,R,L),ponderi(L,Rp), aparitii(A,R,N1), N is N1+1.

%aparitii(Elem,Lista,Nr)
aparitii(_,[],0).
aparitii(A,[A|L],N) :- aparitii(A,L,N1), N is N1+1,!.
aparitii(A,[_|L],N) :- aparitii(A,L,N).

%majoritar(ListaExemple, Val). Cand setul de exem. nu e complet.
majoritar(Le,V) :- categorii(Le,Lc), ponderi(Lc,Lp), ponderent(Lp,V,_).

%id3(ListaEntr,ListaExem,Arbore)
id3(_,[],error).
id3(_,J,t(C,nil,nil)) :- cert(J), J=[(_,C)|_],!.
id3([],L,C) :- majoritar(L,C),!.
id3(Len,Lex,t(N,S,D)) :-
	min(Len,_,(N,_)),
	atribut(N,True,False),	
	split(N,True,Len,Lex,LenTrue,LexTrue),
	split(N,False,Len,Lex,LenFalse,LexFalse),
	id3(LenFalse,LexFalse,S),
	id3(LenTrue,LexTrue,D).

%split(Atribut,Val,L1,L2,S1,S2)
split(N,V,L1,L2,S1,S2) :- 
	calcentr(N,Entr),
	del(Entr,L1,S1),
	splitexem(N,V,L2,S2).

splitexem(N,V,L1,S1) :- 
	findall(M,match([N,V],L1,M),S1).

%match(Enunt,ListaEx,ExempluPotrivit); Enunt=(Atrib,Val)
match(En,[(L,C)|_],(L,C)) :- apare(En,L).
match(En,[_|T],Ex) :- match(En,T,Ex).

%apare(Enunt,ListaAtribCuVal)
apare(E,[E|_]).
apare(E,[_|T]) :- apare(E,T).

%tree(Arbore)
tree(A) :- entropia(E), joc(J), id3(E,J,A).

%afla
afla :- write('Raspundeti cu da/nu'), nl, tree(A), intreaba(A).

% Stg - Fals, Dr - Corect
intreaba(t(N,nil,nil)) :- nl, write('Astazi joci '), write(N), nl,!.
intreaba(t(N,S,_)) :- write(N), write('?'), nl, read(R), R='nu', intreaba(S),!.
intreaba(t(_,_,D)) :- intreaba(D).










