#include "net.h"
#include "tdnet.h"

#define MAX_TRIALS	100000

FILE	*fd1, *fd2;

void
generate_inputs(float *input)
{
	int i;

	srand((time_t)time(NULL));
	
	for(i = 0; i < NR_INPUT_NODES; i++)
		input[i] = (float)((rand() + 0.0) / RAND_MAX);
}

float
get_correct_response(float *input)
{
	float	response = 0;

	/* TOADD generate correct response */

	return response;
}

void
reinforcement_learning()
{
	int		i, reward;
	float	tderror, old_response;
	tdnet_t	tdnet;

	printf("Reinforcement learning started\n");

	init_tdnet(&tdnet);

	generate_inputs(tdnet.input);
	activate_tdnet(&tdnet);
	old_response = tdnet.response;
	update_eligibilities(&tdnet);
	for( i = 0; i < MAX_TRIALS; i++)
	{
		generate_inputs(tdnet.input);
		activate_tdnet(&tdnet);
		
		if(tdnet.response == get_correct_response(tdnet.input))
			reward = 1;
		else
			reward = 0;
		tderror	= reward * tdnet.gamma * tdnet.response - old_response;
		tdlearn(&tdnet, tderror);

		generate_inputs(tdnet.input);
		activate_tdnet(&tdnet);
		old_response = tdnet.response;
		
		update_eligibilities(&tdnet);

		fprintf(fd2, "%G\n", tderror);
	}
	printf("Reinforcement learning ended\n");

	//Evaluation pahse
	do
	{
		printf("Introduceti numerele: ");
		scanf("%f %f", &tdnet.input[0], &tdnet.input[1]);
		activate_tdnet(&tdnet);
		printf("%f + %f = %f(%G)\n",
			tdnet.input[0], tdnet.input[1],
			get_correct_response(tdnet.input),
			tdnet.response);
	}
	while(tdnet.input[0] != 0);
}

void
supervised_learning()
{
	int		i;
	float	error, correct;
	net_t	net;
	
	printf("Supervised learning started\n");
	
	init_net(&net);

	for( i = 0; i < MAX_TRIALS; i++)
	{
		generate_inputs(net.input);

		correct	= get_correct_response(net.input);
		activate_net(&net);
		error	= correct - net.response;
		
		fprintf(fd1, "%G\n", error);
		
		learn(&net, error);
		if(error < 0.0001 && error > -0.0001) break;
	}
	printf("Supervised learning ended\n");
	//Evaluation pahse
	do
	{
		printf("Introduceti numerele: ");
		scanf("%f %f", &net.input[0], &net.input[1]);
		activate_net(&net);
		printf("%f + %f = %f(%G)\n",
			net.input[0], net.input[1],
			get_correct_response(net.input),
			net.response);
	}
	while(net.input[0] != 0);
}

int
main(int argc, char** argv)
{	
	if(argc != 3)
	{
		printf("Syntax: train net.out.file tdnet.out.file\n");
		exit(1);
	}

	if(NULL == (fd1 = fopen(argv[1], "w"))) exit(2);
	if(NULL == (fd2 = fopen(argv[2], "w"))) exit(3);

	printf("This program trains two neural networks\n");

	supervised_learning();
	reinforcement_learning();

	fclose(fd1);
	fclose(fd2);
	printf("Training phase has ended\n");
}
