#ifndef __NET_H
#define __NET_H

#include <stdlib.h>
#include "defs.h"

#define	ALPHA		0.0001

typedef struct
{
	float	input[NR_INPUT_NODES];		/* input nodes activations */
	float	hidden[NR_HIDDEN_NODES];	/* hidden nodes activations */
	float	response;					/* output node activation */

	float	i2h[NR_INPUT_NODES][NR_HIDDEN_NODES];/* weights for input-hidden connections */
	float	h2o[NR_HIDDEN_NODES];		/* weights for hidden-output connections */

	float	alpha;						/* learning rate */
}net_t;

void	init_net(net_t* net);
void	activate_net(net_t* net);
void	learn(net_t* net, float error);
void	save_net(net_t* net, char* file);
void	load_net(net_t* net, char* file);

#endif