#ifndef __TDNET_H
#define __TDNET_H

#include "defs.h"

#define	TDALPHA	(1.0 / NR_INPUT_NODES)
#define	TDBETA	(1.0 / NR_HIDDEN_NODES)
#define	GAMMA	0.9
#define	LAMBDA	0.89

typedef struct
{
	float	input[NR_INPUT_NODES];		/* input nodes activations */
	float	hidden[NR_HIDDEN_NODES];	/* hidden nodes activations */
	float	response;					/* output node activation */

	float	i2h[NR_INPUT_NODES][NR_HIDDEN_NODES];/* weights for input-hidden connections */
	float	h2o[NR_HIDDEN_NODES];		/* weights for hidden-output connections */

	float	ei2h[NR_INPUT_NODES][NR_HIDDEN_NODES];
	float	eh2o[NR_HIDDEN_NODES];

	float	alpha;			/* 1st layer learning rate (typically 1/n) */
	float	beta;			/* 2nd layer learning rate (typically 1/num_hidden) */
	float	gamma;			/* discount-rate parameter (typically 0.9) */
	float	lambda;			/* trace decay parameter (should be <= gamma) */
}tdnet_t;

void	init_tdnet(tdnet_t* net);
void	activate_tdnet(tdnet_t* net);
void	tdlearn(tdnet_t* net, float error);
void	update_eligibilities(tdnet_t* net);
void	save_tdnet(tdnet_t* net, char* file);
void	load_tdnet(tdnet_t* net, char* file);

#endif